/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/*
 * This code has been autogenerated, do not edit
 */

#include <stdlib.h>
#include <string.h>

#include "UsbProConfMsg.h"
#include "UsbProConfMsgSerRep.h"

UsbProConfMsgSerRep::UsbProConfMsgSerRep() {}
UsbProConfMsgSerRep::~UsbProConfMsgSerRep() {}



  
/*
 *
 */
const uint8_t *UsbProConfMsgSerRep::get_serial(unsigned int *len) const {
  *len = UsbProConfMsgSerRep::SERIAL_SIZE;
  return m_serial;
}

/*
 *
 */
int UsbProConfMsgSerRep::get_serial(uint8_t *buf, unsigned int len) const {
  unsigned int l = UsbProConfMsgSerRep::SERIAL_SIZE < len ? UsbProConfMsgSerRep::SERIAL_SIZE  : len ;

  if( buf == NULL)
  	return -1;
  memcpy(buf, m_serial, l);
  return l ;
}

/*
 *
 */
void UsbProConfMsgSerRep::set_serial(uint8_t *v, unsigned int len) {
  unsigned int l = sizeof(m_serial) < len ? sizeof(m_serial) : len;
  memcpy(m_serial, v, l);
}


/*
 * Pack this object into it's struct
 *
 */
int UsbProConfMsgSerRep::pack(uint8_t *buf, unsigned int len) const {
  unsigned int l = sizeof(lla_usbpro_conf_msg_ser_rep) + lla_usbpro_conf_header_size;
  lla_usbpro_conf_msg *p = (lla_usbpro_conf_msg*) buf;

  if (buf == NULL || len < l) {
    return -1;
  }

  p->op = LLA_USBPRO_CONF_MSG_SER_REP;

  p->plugid = 5;

  p->data.ser_rep.status = m_status;
  memcpy(p->data.ser_rep.serial, m_serial, 4);
  return l;
}


/*
 * Prints the ACSII representation of this message
 */
void UsbProConfMsgSerRep::print() const {

  printf("UsbProConfMsgSerRep:\n");
  printf(" op: %hx\n", LLA_USBPRO_CONF_MSG_SER_REP);
  printf(" %s %i\n", "status" , m_status);

}
